<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::group(['middleware' => ['cache.headers:private;max_age=0','cors']], function(){
    Route::get('/bazzreach/search', 'App\Http\Controllers\BazzReachController@search')->name('bazzreach.search');
    Route::get('/bazzreach/bazzsearch', 'App\Http\Controllers\BazzReachController@bazzsearch')->name('bazzreach.bazzsearch');
    Route::post('/bazzreach/{bazzreach}/analysis', 'App\Http\Controllers\BazzReachController@analysis')->name('bazzreach.analysis');
    Route::get('/bazzreach/{bazzreach}/result', 'App\Http\Controllers\BazzReachController@result')->name('bazzreach.result');
    Route::resource('/bazzreach', App\Http\Controllers\BazzReachController::class);
});