import moment from 'moment/moment';
import 'moment/locale/ja';
import {getSearchData,setBazzData,getBazzSearchData,setAnalysis,getBazzAnalysisData,setMemo,delBazzData} from 'backend/getBazzReachApi.jsw';

moment.locale('ja');

let selectIndex = 0;
let selectTableData;
let viewAnalysisFlg = true;

let slideOptions = {
  "duration":   500,
  "delay":      0,
  "direction":  "top"
};

let puffOptions = {
  "duration":   500,
  "delay":      0
};

let rollOptions = {
  "duration":   4000,
  "delay":      0,
  "direction":  "top"
};

let rollOptions1 = {
  "duration":   1500,
  "delay":      0,
  "direction":  "left"
};

let rollOptions2 = {
  "duration":   1000,
  "delay":      0,
  "direction":  "left"
};

let fadeOptions = {
  "duration":   500,
  "delay":      0
};

$w.onReady(function () {
  getBazzSearchData("").then( (result) => {
    init();
    initBazzSearchData(result[0]);
    $w("#bazzSearchDataCount").text = String(result[0].length);
    selectTableData = result[0];
    $w("#bazzSearchTable").pagination = {"type": "pagination", "rowsPerPage": 10};
    $w("#bazzSearchTable").dataFetcher = getRows;
  }).catch(err => {
    viewInfo("f[^ǂݍݎɃG[܂");
    console.log(err, "f[^ǂݍݎɃG[܂");
  });
});

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function search_click(event) {
  $w("#search").disable();
  let search_word = $w("#searchWord").value;
  if(search_word != ""){
    getSearchData(search_word).then( (result) => {

      if($w("#saveTweetStrip").collapsed){
        $w("#saveTweetStrip").expand().then( ( ) => {
          $w("#viewSearchWord").text = search_word;
          $w("#viewSearchData").value = result[0];
          $w("#saveTweetStrip").show("slide",slideOptions).then( ( ) => {
            $w("#search").enable();
          } );
        } );
      }else{
        $w("#saveTweetStrip").hide("slide",slideOptions).then( ( ) => {
          $w("#viewSearchWord").text = search_word;
          $w("#viewSearchData").value = result[0];
          $w("#saveTweetStrip").show("slide",slideOptions).then( ( ) => {
            $w("#search").enable();
          } );
        } );
      }
    }).catch(err => {
      viewInfo("cC[gɃG[܂");
      console.log(err, "cC[gɃG[܂");
    $w("#search").enable();
    });
  }else{
    $w("#search").enable();
  }
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function saveTweet_click(event) {
  $w("#saveTweet").disable();
  setBazzData($w("#viewSearchWord").text,$w("#viewSearchData").value).then( (result) => {
    bazzSearch_click(event);
    viewInfo("cC[gۑ܂");
    $w("#saveTweetStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#viewSearchWord").text = "";
      $w("#viewSearchData").value = "";
      $w("#saveTweetStrip").collapse();
      $w("#saveTweet").enable();
    } );
  }).catch(err => {
    viewInfo("cC[gۑɃG[܂");
    console.log(err, "cC[gۑɃG[܂");
    $w("#saveTweet").enable();
  });
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function bazzSearch_click(event) {
  $w("#bazzSearch").disable();
  let keyword = $w("#keyword").value;
	getBazzSearchData(keyword).then( (result) => {
    initBazzSearchData(result[0]);
    $w("#bazzSearchDataCount").text = String(result[0].length);
    selectTableData = result[0];
    $w("#bazzSearchTable").pagination = {"type": "pagination", "rowsPerPage": 10};
    $w("#bazzSearchTable").dataFetcher = getRows;
    $w("#bazzSearch").enable();
  }).catch(err => {
    viewInfo("f[^ɃG[܂");
    console.log(err, "f[^ɃG[܂");
    $w("#bazzSearch").enable();
  });
}

/**
*	Adds an event handler that runs when a table row is selected.
	[Read more](https://www.wix.com/corvid/reference/$w.Table.html#onRowSelect)
*	 @param {$w.TableRowEvent} event
*/
export function bazzSearchTable_rowSelect(event) {
  selectIndex = event.rowIndex;
  viewAnalysisFlg = true;
  let selectData = $w("#bazzSearchTable").rows[selectIndex];
  let total_tweets = selectData.total_tweets;

  if($w("#selectBazzDataStrip").collapsed){
    $w("#selectBazzDataStrip").expand().then( ( ) => {
      $w("#selectKeyword").text = selectData.search_word;
      $w("#selectBazzData").value = total_tweets;
      $w("#memo").value = selectData.comment;
      $w("#selectBazzDataStrip").show("slide",slideOptions);
  	} );
  }else{
    $w("#selectBazzDataStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#selectKeyword").text = selectData.search_word;
      $w("#selectBazzData").value = total_tweets;
      $w("#memo").value = selectData.comment;
      $w("#selectBazzDataStrip").show("slide",slideOptions);
  	} );
  }

  if(!$w("#analysisStrip").hidden){
    $w("#analysisStrip").hide("slide",slideOptions).then( ( ) => {
        $w("#analysisStrip").collapse();
    } );
  }

  if(!$w("#memoStrip").hidden){
    $w("#memoStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#memoStrip").collapse();
  	} );
  }
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function viewAnalysis_click(event) {
  $w("#viewAnalysis").disable();
  
  if($w("#analysisStrip").collapsed){
    $w("#analysisStrip").expand().then( async( ) => {
      if(viewAnalysisFlg){
        let selectData = $w("#bazzSearchTable").rows[selectIndex];
        if(selectData.sentiment_analysis == ""){
          await setAnalysis(selectData.id).then( (result) => {
          }).catch(err => {
            viewInfo("ڍו͎sɃG[܂");
            console.log(err, "ڍו͎sɃG[܂");
          });

          await bazzSearch_click(event);
        }

        await getBazzAnalysisData(selectData.id).then( async(result) => {
          selectTableData = result[0];
          $w("#sentimentsTable").pagination = {"type": "pagination", "rowsPerPage": 10};
          $w("#sentimentsTable").dataFetcher = await getRows;
          
          selectTableData = result[1];
          $w("#keyPhrasesTable").pagination = {"type": "pagination", "rowsPerPage": 10};
          $w("#keyPhrasesTable").dataFetcher = await getRows;
          viewAnalysisFlg = false;
        }).catch(err => {
          viewInfo("ڍו͌ʎ擾ɃG[܂");
          console.log(err, "ڍו͌ʎ擾ɃG[܂");
        });

      }

      $w("#analysisStrip").show("slide",slideOptions).then( ( ) => {
        $w("#viewAnalysis").enable();
      } );
  	} );
  }else{
    $w("#analysisStrip").hide("slide",slideOptions).then( ( ) => {
       $w("#analysisStrip").collapse();
       $w("#viewAnalysis").enable();
  	} );
  }
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function viewMemoInput_click(event) {
  $w("#viewMemoInput").disable();
  if($w("#memoStrip").collapsed){
    $w("#memoStrip").expand().then( ( ) => {
      $w("#memoStrip").show("slide",slideOptions).then( ( ) => {
        $w("#viewMemoInput").enable();
      } );
  	} );
  }else{
    $w("#memoStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#memoStrip").collapse();
      $w("#viewMemoInput").enable();
  	} );
  }
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function saveMemo_click(event) {
  $w("#saveMemo").disable();
  let selectData = $w("#bazzSearchTable").rows[selectIndex];
  setMemo(selectData.id,$w("#memo").value).then( (result) => {
    bazzSearch_click(event);
    viewInfo("ۑ܂");
    $w("#memoStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#memoStrip").collapse();
      $w("#saveMemo").enable();
    } ); 
  }).catch(err => {
    viewInfo("ۑɃG[܂");
    console.log(err, "ۑɃG[܂");
    $w("#saveMemo").enable();
  });
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function deleteConfirm_click(event) {
  $w("#deleteConfirm").disable();
  viewConfirm("f[^폜Ă낵łH");
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function cancel_click(event) {
  $w("#cancel").disable();
	$w("#confirm").hide("puff",puffOptions).then( ( ) => {
    $w("#cancel").enable();
    $w("#deleteConfirm").enable();
  } );
}

/**
*	Adds an event handler that runs when the element is clicked.
	[Read more](https://www.wix.com/corvid/reference/$w.ClickableMixin.html#onClick)
*	 @param {$w.MouseEvent} event
*/
export function delete_click(event) {
  $w("#delete").disable();
  let selectData = $w("#bazzSearchTable").rows[selectIndex];
  delBazzData(selectData.id).then( (result) => {
    bazzSearch_click(event);
    $w("#confirm").hide("puff",puffOptions).then( ( ) => {
      $w("#delete").enable();
      $w("#deleteConfirm").enable();
    } );

    $w("#selectBazzDataStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#selectKeyword").text = "";
      $w("#selectBazzData").value = "";
      $w("#memo").value = "";
      $w("#selectBazzDataStrip").collapse();
    } );

    $w("#analysisStrip").hide("slide",slideOptions).then( ( ) => {
       $w("#analysisStrip").collapse();
  	} );

    $w("#memoStrip").hide("slide",slideOptions).then( ( ) => {
      $w("#memoStrip").collapse();
  	} );

  }).catch(err => {
    viewInfo("f[^폜ɃG[܂");
    console.log(err, "f[^폜ɃG[܂");
    $w("#delete").enable();
    $w("#deleteConfirm").enable();
  });
}

function viewInfo(message){

  let puffInfoOptions = {
    "duration":   500,
    "delay":      2000
  };

  $w("#confirmText").text = message;
  $w("#confirmBtn").hide();
  $w("#confirm").show("puff",puffOptions).then( ( ) => {
    $w("#confirm").hide("puff",puffInfoOptions)
  } );
}

function init(){
  $w("#preLoader").hide("fade",fadeOptions);
  $w("#searchWordStrip").show("fade",fadeOptions);
  $w("#bazzSearchStrip").show("fade",fadeOptions);
  $w("#bazzSearchTableStrip").show("fade",fadeOptions);
  $w("#copy").show("roll",rollOptions).then( ( ) => {
    $w("#title").show("roll",rollOptions1).then( ( ) => {
      $w("#subCopy").show("roll",rollOptions2);
    } );
  } );
}

function initBazzSearchData(searchData) {
  searchData.forEach(function(item) {
    let date = new Date(item.created_at);

    if(item.total_tweets.length > 50){
      item.tweets_short = item.total_tweets.substr(0, 50);
      item.tweets_short += "c";
    }else{
      item.tweets_short = item.total_tweets;
    }

    if(item.sentiment_analysis == null){
      item.sentiment_analysis = "";
    }

    item.create_passed = moment(date, 'YYYY/MM/DD HH:mm:S').fromNow();
    
  });
}

function getRows(startRow, endRow) {
  return new Promise( (resolve, reject) => {
    const fetchedDataRows = selectTableData.slice(startRow, endRow);
    resolve( {
      pageRows: fetchedDataRows,
      totalRowsCount: selectTableData.length
    } );
  } );
}

function viewConfirm(message){
  $w("#confirmText").text = message;
  $w("#confirmBtn").show();
  $w("#confirm").show("puff",puffOptions);
}